import { isFunction } from '@agile-ts/utils';
import { LogCodeManager } from './logCodeManager.js';
import { Agile } from './agile.js';

let sharedAgileInstance = new Agile({
  key: "shared"
});
function assignSharedAgileInstance(agileInstance) {
  sharedAgileInstance = agileInstance;
}
function getAgileInstance(instance) {
  try {
    if (instance != null) {
      const _agileInstance = isFunction(instance["agileInstance"]) ? instance["agileInstance"]() : instance["agileInstance"];
      if (_agileInstance)
        return _agileInstance;
    }
    if (sharedAgileInstance instanceof Agile) {
      return sharedAgileInstance;
    }
    return globalThis[Agile.globalKey];
  } catch (e) {
    LogCodeManager.log("20:03:00", [], instance);
  }
  return void 0;
}

export { assignSharedAgileInstance, getAgileInstance, sharedAgileInstance as shared, sharedAgileInstance };
